/*
    Copyright (C) 2012  Leonardo Pozzati
    This file is part of MetastableRandWalk.

    MetastableRandWlak is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    MetastableRandWalk is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Nome-Programma.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "libPrint.h"

using namespace std;

							//LIBPRINT
//FRAME DENS PRINT
void frDensPrint(ofstream &outFile,
				 map<unsigned long,
					 pair <unsigned long, unsigned long > >
				 frCountVsNorm,
				 unsigned long trapped,
				 unsigned long time) {
	map<unsigned long,pair<unsigned long,unsigned long> >::iterator it1;
	//scrivo l'output nel file
	outFile << "{";
	for(it1=frCountVsNorm.begin(); it1!=frCountVsNorm.end(); it1++) {
		outFile << (*it1).first
					<< ": " 
					<< ( (double)((*it1).second).first ) / 
					     ((*it1).second).second
					<< ", ";
	}
	outFile << "'tempo': " << time << ", "
				<< "'trapped': "<< trapped << "}" << endl;
}

//CROWN DENS PRINT
void crDensPrint(ofstream &outFile,
				 map<unsigned long,
					 pair <unsigned long, unsigned long > >
				 crCountVsNorm,
				 unsigned long trapped,
				 unsigned long time) {
	map<unsigned long,pair<unsigned long,unsigned long> >::iterator it1;
	//scrivo l'output nel file
	outFile << "{";
	for(it1=crCountVsNorm.begin(); it1!=crCountVsNorm.end(); it1++) {
		outFile << (*it1).first
					<< ": "
					<< ( (double)((*it1).second).first ) /
						 ((*it1).second).second
					<< ", ";
	}
	outFile << "'tempo': " << time << ", "
				<< "'trapped': "<< trapped << "}" << endl;
}


//Report file print
void reportPrint(ofstream &outFile,
				 map<string, string> param,
				 time_t simSeed,
				 long time,
				 string label1,
				 unsigned long var1,
				 string label2,
				 unsigned long var2) {

	outFile << "-Report simulazione" << endl;
	map<string, string>::iterator it1;
	for(it1 = param.begin(); it1 != param.end(); it1++) {
		outFile << "-" << (*it1).first << ": " 
					<< (*it1).second << endl;
	}
	if (label1 != "") {
		outFile << label1 << ": " << var1 << endl;
	}
	if (label2 != "") {
		outFile << label2 << ": " << var2 << endl;
	}
	outFile << "Seme: " << simSeed << endl;
	outFile << "Millisecondi trascorsi: " << time << endl;
}
