/*
    Copyright (C) 2012  Leonardo Pozzati
    This file is part of MetastableRandWalk.

    MetastableRandWlak is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    MetastableRandWalk is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Nome-Programma.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "parseLib.h"

using namespace std;

void showVect(vector<string> toBeShown, string warning) {
	if(toBeShown.size()) {
		cout << warning << endl;
		vector<string>::iterator it1;
		for(it1=toBeShown.begin(); it1!=toBeShown.end(); it1++) {
			cout << *it1 << " ";
		} cout << endl;
	}
}

vector<string> arrayToVector(string array1[],
						 int len1,
						 string array2[] = NULL,
						 int len2 = 0) {
	vector<string> join;
	int i = 0;
	while(i < len1) {
		if(array1[i] != ":" && array1[i] != "::") {
			join.push_back(array1[i]);
		}
		i++;
	}
	i = 0;
	while(i < len2) {
		if(array2[i] != ":" && array2[i] != "::") {
			join.push_back(array2[i]);
		}
		i++;
	}	
	return join;
}

vector<string> arrayRangeToVector(string array[], int len1,
								  string start,
								  string stop) {
	vector<string> container;
	int begin = 0;
	int end = len1;
	for(int i = 0; i < len1; i++) {
		if(array[i] == start) {
			begin = i + 1;
		} else if(array[i] == stop) {
			end = i;
		}
	}
	for(int i = begin; i < end; i++) {
		container.push_back(array[i]);
	}
	return container;
}

void mapSecureInsert(map<string, unsigned> &mappa, string item) {
	if(mappa.count(item)) {
		mappa[item] += 1;
	} else {
		mappa.insert(pair<string, unsigned>(item,1));
	}
}

void vectorSecureInsert(vector<string> &vettore, string item) {
	if(!count(vettore.begin(), vettore.end(), item)) {
		vettore.push_back(item);
	}
}

void showMap1(map<string, unsigned> toBeShown, string warning) {
	if(toBeShown.size()) {
		cout << warning << endl;
		map<string, unsigned>::iterator it1;
		for(it1=toBeShown.begin(); it1!=toBeShown.end(); it1++) {
			cout << (*it1).first << ": " << (*it1).second << endl;
		} cout << endl;
	}
}

void showMap2(map<string, string> toBeShown, string warning) {
	if(toBeShown.size()) {
		cout << warning << endl;
		map<string, string>::iterator it1;
		for(it1=toBeShown.begin(); it1!=toBeShown.end(); it1++) {
			cout << (*it1).first << ": " << (*it1).second << endl;
		} cout << endl;
	}
}

map<string, string> inputScan(string mandatory[], int len1,
							  string optional[], int len2,
							  char *input[], int len3) {
	map<string, string> returned;
	map<string, unsigned> repeated;
	map<string, unsigned> notAllowed;
	vector<string> checked;
	vector<string> missing;
	vector<string> notSet;
	vector<string> unmanageable;
	
	vector<string> mandOpt = arrayToVector(mandatory, len1);
	vector<string> optOpt = arrayToVector(optional, len2);
	vector<string> allOpt = arrayToVector(mandatory, len1, optional, len2);
	vector<string> mandValue = arrayRangeToVector(optional, len2, "", ":");	//parametri opzionali con valore obbligatorio
	vector<string> optValue = arrayRangeToVector(optional, len2, ":", "::");	//parametri opzionali con valore opzionale
	vector<string> param(input + 1, input + len3);
	vector<string>::iterator it1;

	for(it1 = param.begin(); it1 != param.end(); ) {
		if(count(mandOpt.begin(), mandOpt.end(), *it1)) {
			if(count(param.begin(), param.end(), *it1) > 1) {
				mapSecureInsert(repeated, *it1);
				vectorSecureInsert(checked, *it1);
				if(param.end() - it1 >= 2 &&
				   count(allOpt.begin(), allOpt.end(), *(it1+1)) == 0) {
					it1 += 2;
				} else {
					it1++;
				}
			} else {
				if(param.end() - it1 >= 2 &&
				   count(allOpt.begin(), allOpt.end(), *(it1+1)) == 0) {
					checked.push_back(*it1);
					returned.insert(pair<string,string>(*it1,*(it1+1)));
					it1 += 2;
				} else {
					checked.push_back(*it1);
					notSet.push_back(*it1);
					it1++;
				}
			}
		}


		else if(count(optOpt.begin(), optOpt.end(), *it1)) {
			if(count(param.begin(), param.end(), *it1) > 1) {
				mapSecureInsert(repeated, *it1);
				if(param.end() - it1 >= 2 &&
				   count(allOpt.begin(), allOpt.end(), *(it1+1)) == 0) {
					it1 += 2;
				} else {
					it1++;
				}
			} else {
				if(count(mandValue.begin(), mandValue.end(), *it1)) {
					if(param.end() - it1 >= 2 &&
					   count(allOpt.begin(), allOpt.end(), *(it1+1)) == 0) {
						returned.insert(pair<string,string>(*it1,*(it1+1)));
						it1 += 2;
					}
					else {
						unmanageable.push_back(*it1);
						it1++;
					}
				}
				else if(count(optValue.begin(), optValue.end(), *it1)) {
					if((param.end() - it1 >= 2) &&
					   count(allOpt.begin(), allOpt.end(), *(it1+1)) == 0) {
							returned.insert(pair<string,string>(*it1,*(it1+1)));
							it1 += 2;
						}
					else {
							returned.insert(pair<string,string>(*it1,"NaV"));
							it1++;
						}
				}
				else {
					returned.insert(pair<string,string>(*it1,"NaV"));
					it1++;
				}
			}
		}
		else {
			mapSecureInsert(notAllowed, *it1);
			it1++;
		}
	}
	if(checked.size() != mandOpt.size()) {
		for(it1=mandOpt.begin(); it1 != mandOpt.end(); it1++) {
			if(!count(checked.begin(), checked.end(), *it1)) {
				missing.push_back(*it1);
			}
		}
	}
	if(repeated.size() || notAllowed.size() ||
	   missing.size() || notSet.size() || unmanageable.size() ) {
		cout << "Sono stati trovati seguenti problemi nel parsing:\n";
		showMap1(repeated, "Ripetizioni (parametro: ricorrenze)");
		showMap1(notAllowed, "Non permessi (parametro: ricorrenze)");
		showVect(missing, "Parametri obbligatori non passati");
		showVect(notSet, "Parametri non correttamente impostati");
		showVect(unmanageable, "Parametri non gestibili");
		exit(1);
	}
	return returned;
}

